using System;
using NUnit.Framework;

namespace Smdn.Net.Imap4 {
  [TestFixture]
  public class ImapSearchResultOptionsTest {
    [Test]
    public void TestSave()
    {
      var options = ImapSearchResultOptions.Save;

      Assert.AreEqual("(SAVE)", options.ToString());

      var caps = (options as IImapExtension).RequiredCapabilities;

      CollectionAssert.AreEquivalent(new[] {
                                      ImapCapability.ESearch,
                                      ImapCapability.ESort,
                                      ImapCapability.Searchres,
                                     },
                                     caps);
    }
  }
}